*** emacs18.59.OLD/x11fns.c	Sat Nov 21 13:44:48 1992
--- emacs18.59.NEW/x11fns.c	Sat Nov 21 13:44:49 1992
***************
*** 924,929 ****
--- 924,945 ----
  
  #endif foobar
  
+ DEFUN ("tk-get-event-window", Ftk_get_event_window,
+        Stk_get_event_window, 0, 0, 0,
+        "Returns the event window id.")
+   ()
+ {
+ 	extern Window XXeventWindow;
+ 
+ 	Lisp_Object string;
+ 	char tmpBuffer[30];
+ 
+ 	check_xterm ();
+ 	sprintf(tmpBuffer, "%ld", XXeventWindow);
+ 	string = build_string (tmpBuffer);
+ 	return string;
+ }
+ 
  XExitWithCoreDump ()
  {
  	XCleanUp ();
***************
*** 1014,1019 ****
--- 1030,1036 ----
    defsubr (&Sx_rebind_keys);
  #endif notdef
    defsubr (&Sx_debug);
+   defsubr (&Stk_get_event_window);
  }
  
  #endif /* HAVE_X_WINDOWS */
*** emacs18.59.OLD/x11term.c	Sat Nov 21 13:44:48 1992
--- emacs18.59.NEW/x11term.c	Sat Nov 21 13:44:49 1992
***************
*** 210,215 ****
--- 210,219 ----
  Display *XXdisplay;
  int XXscreen;
  Window XXwindow;
+ Window XXeventWindow;
+ Window Vtk_event_window;
+ Lisp_Object Vtk_widget;
+ char *tmp_tk_widget;
  GC XXgc_norm,XXgc_rev,XXgc_curs,XXgc_temp,XXgc_curs_rev;
  XGCValues XXgcv;
  Cursor EmacsCursor;
***************
*** 1354,1360 ****
  			
      case ConfigureNotify:
        if (abs(pixelheight-event.xconfigure.height) >= XXfonth
! 	  || abs(pixelwidth-event.xconfigure.width) >= XXfontw)
  	{
  	  int rows, cols;
  
--- 1358,1365 ----
  			
      case ConfigureNotify:
        if (abs(pixelheight-event.xconfigure.height) >= XXfonth
! 	  || abs(pixelwidth-event.xconfigure.width) >= XXfontw
! 	  || XXeventWindow)
  	{
  	  int rows, cols;
  
***************
*** 1736,1741 ****
--- 1741,1748 ----
  	XXscreen = DefaultScreen (XXdisplay);
  	XXisColor = DisplayCells (XXdisplay, XXscreen) > 2;
  	XXColorMap = DefaultColormap (XXdisplay, XXscreen);
+ 	XXwindow = 0;
+ 	XXeventWindow = 0;
  
  	XSetErrorHandler (x_error_handler);
  	XSetIOErrorHandler (x_io_error_handler);
***************
*** 1924,1929 ****
--- 1931,1956 ----
  			xxargc--;
  			xxargv++;
  		}
+ 		if ((xxargc > 4) && !strcmp (*xxargv, "-tkwidget")) {
+ 		  xxargc--;
+ 		  xxargv++;
+ 		  if (**xxargv == '0' && *(*xxargv+1) == 'x') {
+ 		    sscanf(*xxargv+2,"%x",&XXwindow);
+ 		  } else {
+ 		    XXwindow = atol(*xxargv);
+ 		  }
+ 		  xxargc--;
+ 		  xxargv++;
+ 		  tmp_tk_widget =
+ 		    (char *) xmalloc (strlen (*xxargv)+1);
+ 		  strcpy (tmp_tk_widget, *xxargv);
+ 		  xxargc--;
+ 		  xxargv++;
+ 		  xxargc--;
+ 		  xxargv++;
+ 		  xxargc--;
+ 		  xxargv++;
+ 		}
  		if (XXisColor) {
  			if ((xxargc > 1 && !strcmp (*xxargv, "-fg"))) {
  			        xxargc--;
***************
*** 2412,2419 ****
      sizehints.flags |= PResizeInc|PMinSize;
  
  
!     sizehints.x = x;
!     sizehints.y = y;
      sizehints.width = width*XXfontw + 2 * XXInternalBorder;
      sizehints.height = height*XXfonth + 2 * XXInternalBorder;
  
--- 2439,2448 ----
      sizehints.flags |= PResizeInc|PMinSize;
  
  
!     if(!XXeventWindow) {
!       sizehints.x = x;
!       sizehints.y = y;
!     }
      sizehints.width = width*XXfontw + 2 * XXInternalBorder;
      sizehints.height = height*XXfonth + 2 * XXInternalBorder;
  
***************
*** 2520,2526 ****
      sizehints.flags |= PResizeInc;
  
      XSetWMNormalHints(XXdisplay, w, &sizehints);
!     XConfigureWindow(XXdisplay, w, change_mask, &changes);
  #endif /* not X11R4 */
  }
  
--- 2549,2559 ----
      sizehints.flags |= PResizeInc;
  
      XSetWMNormalHints(XXdisplay, w, &sizehints);
!     if(XXeventWindow) {
!       XResizeWindow(XXdisplay, w, changes.width, changes.height);
!     } else {
!       XConfigureWindow(XXdisplay, w, change_mask, &changes);
!     }
  #endif /* not X11R4 */
  }
  
***************
*** 2579,2585 ****
--- 2612,2620 ----
  XSetWindowSize(rows, cols)
      int rows, cols;
  {
+   if (!XXeventWindow) {
      XT_Set_Size_Hints(XXwindow, 0, 0, cols, rows, NO_MANAGER, 0);
+   }
  }
  
  
***************
*** 2627,2637 ****
        desktop = RootWindow(XXdisplay, DefaultScreen(XXdisplay));
      }
  
!   XXwindow = XCreateSimpleWindow(XXdisplay, desktop,
! 				 x, y,
! 				 width*XXfontw + 2*XXInternalBorder,
! 				 height*XXfonth + 2*XXInternalBorder,
! 				 XXborder, brdr, back);
    if (!XXwindow)
      {
        fprintf (stderr, "Could not create X window!\n");
--- 2662,2686 ----
        desktop = RootWindow(XXdisplay, DefaultScreen(XXdisplay));
      }
  
!   if (!XXwindow) {
!     XXwindow = XCreateSimpleWindow(XXdisplay, desktop,
! 				   x, y,
! 				   width*XXfontw + 2*XXInternalBorder,
! 				   height*XXfonth + 2*XXInternalBorder,
! 				   XXborder, brdr, back);
!   } else {
!     XXeventWindow = XCreateSimpleWindow(XXdisplay, desktop,
! 					x, y,
! 					width*XXfontw + 2*XXInternalBorder,
! 					height*XXfonth + 2*XXInternalBorder,
! 					XXborder, brdr, back);
!     if (!XXeventWindow) {
!       fprintf (stderr, "Could not create X window!\n");
!       fflush (stderr);
!       exit (-97);
!     }
!   }
!    
    if (!XXwindow)
      {
        fprintf (stderr, "Could not create X window!\n");
***************
*** 2676,2691 ****
    XT_Set_Class_Hints(XXwindow);
    XT_Set_Command_Line(XXwindow);
    XT_Set_Host(XXwindow);
!   XT_Set_Title(XXwindow);
!   XT_Set_Icon_Title(XXwindow);
!   XT_Set_Size_Hints(XXwindow, x, y, width, height, False, pr);
    XT_Set_Zoom_Sizes(XXwindow);
    XT_Set_WM_Hints(XXwindow);
  
!   XSelectInput(XXdisplay, XXwindow, KeyPressMask |
! 	       ExposureMask | ButtonPressMask | ButtonReleaseMask |
! 	       EnterWindowMask | LeaveWindowMask | FocusChangeMask |
! 	       StructureNotifyMask);
  
    XMapWindow (XXdisplay, XXwindow);
    XFlush (XXdisplay);
--- 2725,2751 ----
    XT_Set_Class_Hints(XXwindow);
    XT_Set_Command_Line(XXwindow);
    XT_Set_Host(XXwindow);
!   if (!XXeventWindow) {
!     XT_Set_Title(XXwindow);
!     XT_Set_Icon_Title(XXwindow);
!     XT_Set_Size_Hints(XXwindow, x, y, width, height, False, pr);
!   } else {
!     XT_Set_Size_Hints(XXwindow, x, y, width, height, True, pr);
!   }
    XT_Set_Zoom_Sizes(XXwindow);
    XT_Set_WM_Hints(XXwindow);
  
!   if (!XXeventWindow) {
!     XSelectInput(XXdisplay, XXwindow, KeyPressMask |
! 		 ExposureMask | ButtonPressMask | ButtonReleaseMask |
! 		 EnterWindowMask | LeaveWindowMask | FocusChangeMask |
! 		 StructureNotifyMask);
!   } else {
!     XSelectInput(XXdisplay, XXeventWindow, KeyPressMask |
! 		 ExposureMask | ButtonPressMask | ButtonReleaseMask |
! 		 EnterWindowMask | LeaveWindowMask | FocusChangeMask |
! 		 StructureNotifyMask);
!   }
  
    XMapWindow (XXdisplay, XXwindow);
    XFlush (XXdisplay);
